



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>CF494C Helping People 解题报告</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">CF494C Helping People 解题报告</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-27 18:18:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>CF494C Helping People</h1>
<h2>题意翻译</h2>
<p>有一个长为 \(n\) 的数列，初始时为 \(a_{1\dots n}\)。</p>
<p>给你 \(q\) 个操作，第 \(i\) 个操作将 \([l_i,r_i]\) 内的数全部加一，有 \(p_i\) 的概率被执行。保证区间不会交错，即：\(\forall i,j\in[1,q],l_i\le r_i&lt;l_j\le r_j\) 或 \(l_i\le l_j\le r_j\le r_i\) 或 \(l_j\le r_j&lt;l_i\le r_i\) 或 \(l_j\le l_i\le r_i\le r_j\) 。</p>
<p>求操作完成后数列的最大值的期望。</p>
<h3>输入格式</h3>
<p>第一行 \(n,\,q\,(1\le n\le10^5,\,1\le q\le 5000)\)。</p>
<p>第二行 \(a_1,\,a_2,\,\cdots,\,a_n\,(0\le a_i\le10^9)\)。</p>
<p>接下来 \(q\) 行，每行 \(l_i,\,r_i,\,p_i\,(1\le l_i\le r_i\le n,\,0\le p_i\le1)\)。</p>
<h3>输出格式</h3>
<p>一个实数，表示答案，绝对/相对误差在 \(10^{-6}\)内算对。</p>
<p>Translated by ouuan.</p>
<hr>
<p>考虑区间不交错的用处，一个区间向ta完全包含的区间连边，可以构成一棵树。</p>
<p>然后区间又只有5000个，搞一个\(n^2\)的树形dp多好</p>
<p>考虑求出每个最大值的概率。</p>
<p>令\(dp_{i,j}\)代表区间\(i\)最大值不大于\(j+\max_{l\le i\le r}a_i\)的概率，这样等于的概率只需要\(dp_{i,j}-dp_{i,j-1}\)就可以得到了</p>
<p>转移</p>
<p><div>\[dp_{i,j}=p_i\prod_sdp_{s,j+\max_i-\max_v-1}+(1-p_i)\prod_sdp_{s,j+\max_i-\max_v}<br />
\]</div></p>
<p>注意上下边界。</p>
<hr>
<p><strong>Code:</strong></p>
<pre class="prettyprint linenums"><code>#include &lt;cstdio&gt;<br />
#include &lt;algorithm&gt;<br />
#define ls id&lt;&lt;1<br />
#define rs id&lt;&lt;1|1<br />
using std::max;<br />
using std::min;<br />
const int N=5010;<br />
int head[N],to[N&lt;&lt;1],Next[N&lt;&lt;1],cnt;<br />
void add(int u,int v)<br />
{<br />
    to[++cnt]=v,Next[cnt]=head[u],head[u]=cnt;<br />
}<br />
int n,q;<br />
struct node<br />
{<br />
    int l,r,mx;double p;<br />
    bool friend operator &lt;(node a,node b){return a.l==b.l?a.r&gt;b.r:a.l&lt;b.l;}<br />
}s[N];<br />
int mx[N*80];<br />
void build(int id,int l,int r)<br />
{<br />
    int mid=l+r&gt;&gt;1;<br />
    if(l^r) build(ls,l,mid),build(rs,mid+1,r),mx[id]=max(mx[ls],mx[rs]);<br />
    else scanf(&quot;%d&quot;,mx+id);<br />
}<br />
int query(int id,int L,int R,int l,int r)<br />
{<br />
    if(l==L&amp;&amp;r==R) return mx[id];<br />
    int Mid=L+R&gt;&gt;1;<br />
    if(r&lt;=Mid) return query(ls,L,Mid,l,r);<br />
    else if(l&gt;Mid) return query(rs,Mid+1,R,l,r);<br />
    else return max(query(ls,L,Mid,l,Mid),query(rs,Mid+1,R,Mid+1,r));<br />
}<br />
int dep[N];<br />
double dp[N][N];<br />
void dfs(int now)<br />
{<br />
    dep[now]=1;<br />
    for(int i=head[now];i;i=Next[i]) dfs(to[i]),dep[now]=max(dep[now],dep[to[i]]+1);<br />
    for(int j=0;j&lt;=dep[now];j++)<br />
    {<br />
        double f1=j?s[now].p:0,f2=1-s[now].p;<br />
        for(int i=head[now];i;i=Next[i])<br />
        {<br />
            int v=to[i];<br />
            if(j+s[now].mx-s[v].mx-1&gt;=0) f1*=dp[v][min(q+1,j+s[now].mx-s[v].mx-1)];<br />
            f2*=dp[v][min(q+1,j+s[now].mx-s[v].mx)];<br />
        }<br />
        dp[now][j]=f1+f2;<br />
    }<br />
    for(int i=dep[now]+1;i&lt;=q+1;i++) dp[now][i]=1;<br />
}<br />
int main()<br />
{<br />
    scanf(&quot;%d%d&quot;,&amp;n,&amp;q);<br />
    build(1,1,n);<br />
    for(int i=1;i&lt;=q;i++)<br />
    {<br />
        scanf(&quot;%d%d%lf&quot;,&amp;s[i].l,&amp;s[i].r,&amp;s[i].p);<br />
        s[i].mx=query(1,1,n,s[i].l,s[i].r);<br />
    }<br />
    s[++q]={1,n,mx[1],0};<br />
    std::sort(s+1,s+1+q);<br />
    for(int i=2;i&lt;=q;i++)<br />
        for(int j=i-1;j;j--)<br />
            if(s[j].l&lt;=s[i].l&amp;&amp;s[i].r&lt;=s[j].r)<br />
            {<br />
                add(j,i);<br />
                break;<br />
            }<br />
    dfs(1);<br />
    double x=s[1].mx,ans=dp[1][0]*x;<br />
    for(int i=1;i&lt;=dep[1];i++)<br />
        ans+=(dp[1][i]-dp[1][i-1])*(x+i);<br />
    printf(&quot;%.6lf\n&quot;,ans);<br />
    return 0;<br />
}<br />
</code></pre>
<hr>
<p><strong>2019.1.13</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390vk338.html">网络切片在5G中的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwnpxzq.html">crtmpserver系列&lpar;二&rpar;：搭建简易流媒体直播系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2yxvl8.html">Sybase数据库收集表及其索引的统计信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw72mk8.html">EF Code First教程-02 约定配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjdd479.html">&lbrack;pjsip&rsqb;Pjlib中配置文件config&period;h解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvwkoyq.html">【Android - MD】之TabLayout的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydjwejq.html">uboot使用tftp下载时出现&OpenCurlyDoubleQuote;checksum bad&rdquo;问题原因分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1wv3r9.html">一个很奇特的异常 tmpFile&period;renameTo&lpar;classFile&rpar; failed</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjgjgg8.html">pickle模块的使用python3</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj2o5pq.html">Xamarin  android spinner的使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj2ovx9.html">AVFoundation 框架初探究（四）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljyln69.html">Null value was assigned to a property of primitive type setter of com&period;oa&period;manager&period;personnel&period;bean&period;KqAttendanceHoliday&period;dayType</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj36yg8.html">Tupper自我指涉公式生成器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvver38.html">sql server 性能调优之 资源等待之网络I&sol;O</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy6l3x9.html">Linux系统-禁ping</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw2vkj9.html">java 调用process</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjogke9.html">MaidSafe区块链项目白皮书解读</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k2ok3q.html">680C&period; Bear and Prime 100 数学</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pdl60q.html">Apache Hadoop 源码阅读（陆续更新）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdj6j6zq.html">boost 库的安装</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jmjdze9.html">20155238 《JAVA程序设计》实验三（敏捷开发与XP实践）实验报告</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve53nx9.html">Hibernate一对多关联关系保存时的探究</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4nlmpq.html">Express app&period;listen 函数了解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4n231q.html">ubuntu 12&period;04 桌面版关闭图形界面</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyvwlyxq.html">数据库历险记（二） &vert; Redis 和 Mecached 到底哪个好？</a>
			</li>
						<li><a href="https://www.batexi.com/a/963jk4y9.html">stl源码剖析 详细学习笔记 算法&lpar;5&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkgp1x8.html">FastDFS教程Ⅰ-文件服务器安装与Nginx配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2wjk08.html">Docker&lowbar;容器化gitlab</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjm4p28.html">OpenGL：使用顶点数组法绘制正六面体</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kd10vq.html">4、c&plus;&plus; Arx二次开发创建多段线</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
